//+------------------------------------------------------------------+
//|                                                   _RS_Analiz.mq4 |
//|                                                       favoritefx |
//|                                               favoritefx@mail.ru |
//+------------------------------------------------------------------+
#property copyright "favoritefx"
#property link      "favoritefx@mail.ru"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red
//---- input parameters
extern int       HerstPeriod=100;
extern double    a=0.5;
//---- buffers
double ExtMapBuffer1[];
datetime BarTime=0;
double Price[];

bool isNewBar()
  {
//----
   bool res=false; 
   if (BarTime!=Time[0]) 
      {
         BarTime=Time[0];  
         res=true;
      } 
//----
   return(res);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexLabel( 0, "Hurst");
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int    counted_bars=IndicatorCounted();
   if (counted_bars==0)   
      limit=Bars-1;
   if (counted_bars>0)      
      limit = Bars - counted_bars-1;
   
   double sum;
   double Average;
   if (isNewBar())
   {
      double MaxH;
      double MinH;
      double R;      
      for(int j=limit;j>=0;j--)
      {
         int max_index=ArrayMaximum(Close,HerstPeriod+j,j);
         int min_index=ArrayMinimum(Close,HerstPeriod+j,j);
         MaxH=Close[max_index];
         MinH=Close[min_index];
         R=MaxH-MinH;
         Average=iMA(NULL,0,HerstPeriod,0,0,0,j);
         sum=0;
         for (int i=1;i<=HerstPeriod;i++)
             sum+=MathPow((Average-Close[i+j]),2);
         double S=MathSqrt(sum/(HerstPeriod-1));
         if (S>0)
            ExtMapBuffer1[j]=(MathLog(R/S))/(MathLog(HerstPeriod*a));    
      }
   }
   return(0);
  }
//+------------------------------------------------------------------+